/**
 * Defines a Lexicon class that emulates the Lexicon
 * class exported by the Stanford CS106 libraries.
 */

#ifndef _lexicon_
#define _lexicon_

#include <string>
#include "map.h"

class Lexicon {
public:
    Lexicon();
    ~Lexicon();
    
    void add(const std::string& word);
    bool contains(const std::string& word) const;
    bool containsPrefix(const std::string& prefix) const;
    
private:
    struct node *root;
    const struct node *findNode(const std::string& str) const;
    struct node *ensureNodeExists(const std::string& str);
};

#endif
